#!/usr/bin/env python3
import subprocess, ctypes, sys

pk = bytes.fromhex(sys.argv[1])
sk = bytes.fromhex(sys.argv[2])

print(pk.hex())
print(sk.hex())

try:
    lib = ctypes.CDLL('./libemle.so')
except OSError:
    subprocess.check_call('cd Reference_Implementation/crypto_sign/eMLE-Sig-I && gcc -shared -O3 -g -o ../../../libemle.so impl.c fips202.c conv.c aes256ctr.c randvec.c rng.c nist.c -fPIC -lssl -lcrypto', shell=True)
    lib = ctypes.CDLL('./libemle.so')

sm = ctypes.create_string_buffer(9999)
smlen = ctypes.c_ulonglong()
mlen = ctypes.c_ulonglong()
buf = ctypes.create_string_buffer(9999)

for m in [bytes([c]) for c in range(0x100)]:
    lib.crypto_sign(sm, ctypes.pointer(smlen), m, len(m), sk)
    ret = lib.crypto_sign_open(buf, ctypes.pointer(mlen), sm, smlen, pk)
    assert not ret

print('okay')

