#!/usr/bin/env sage

file = './KAT/eMLE-Sig-I/PQCsignKAT_800.rsp'
n = 64

################################################################

# Load data.

pks, sks = [], []
for l in open(file):
    if l.startswith('pk = '):
        pks.append(bytes.fromhex(l.strip().split()[-1]))
    elif l.startswith('sk = '):
        sks.append(bytes.fromhex(l.strip().split()[-1]))

################################################################

# Estimate expected lengths of x,k0',k1,k2.

load('emle-bytes.sage')
load('emle-stuff.sage')

norms = []

for pk,sk in zip(pks,sks):

    h1,h2 = decode_pk(pk)
    x1,x2,F1,F2 = decode_sk(sk)

    for (h, the_x, the_F0, the_F1) in ((h1,x1)+F1, (h2,x2)+F2):
        the_k0 = ((the_F0 -          conv(GG[0], the_x) - conv(GG[0], GG[1])) / pp[0]).change_ring(ZZ)
        the_k1 = ((the_F1 - the_F0 - conv(GG[1], the_x)                     ) / pp[1]).change_ring(ZZ)
        the_k0prime = the_k0 - k0base
        the_k2 = ((h      - the_F1 - conv(GG[2], the_x)                     ) / pp[2]).change_ring(ZZ)
#        print(the_x, the_k0prime, the_k1, the_k2)

        assert h - conv(GG[0],GG[1]) == conv(gprime, the_x) + the_k0*pp[0] + the_k1*pp[1] + the_k2*pp[2]

        norms.append(tuple(vec.norm().n() for vec in (the_x, the_k0prime, the_k1, the_k2)))

print(tuple(sum(nn[i] for nn in norms) / len(norms) for i in range(4)))

